package packet

type (
	// Packer 数据帧 封包/解包
	Packer interface {
		// Pack 封包，将原始数据构造为二进制流数据帧
		Pack(header any, data []byte) ([]byte, error)

		// Unpack 解包
		Unpack(data []byte) ([]IPacket, error)
	}

	// PackerBuilder Packer构建器
	PackerBuilder func() Packer
)
